gi-glib-2.0.17: GLib bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria (garetxe@gmail.com)
Safe Haskell | None
Language | Haskell2010

GI.GLib.Structs.DateTime

Contents

- Exported types
- Methods
  - add
  - addDays
  - addFull
  - addHours
  - addMinutes
  - addMonths
  - addSeconds
  - addWeeks
  - addYears
  - compare
  - difference
  - equal
  - format
  - getDayOfMonth
  - getDayOfWeek
  - getDayOfYear
  - getHour
  - getMicrosecond
  - getMinute
  - getMonth
  - getSecond
  - getSeconds
  - getTimezone
  - getTimezoneAbbreviation
  - getUtcOffset
  - getWeekNumberingYear
  - getWeekOfYear
  - getYear
  - getYmd
  - hash
  - isDaylightSavings
  - new
  - newFromIso8601
  - newFromTimevalLocal
  - newFromTimevalUtc
  - newFromUnixLocal
  - newFromUnixUtc
  - newLocal
  - newNow
  - newNowLocal
  - newNowUtc
  - newUtc
  - ref
  - toLocal
  - toTimeval
  - toTimezone
  - toUnix
  - toUtc
  - unref

Description

`GDateTime` is an opaque structure whose members cannot be accessed directly.

Since: 2.26

Synopsis

- newtype DateTime = DateTime (ManagedPtr DateTime)
- noDateTime :: Maybe DateTime
- dateTimeAdd :: (HasCallStack, MonadIO m) => DateTime -> Int64 -> m DateTime
- dateTimeAddDays :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeAddFull :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> m DateTime
- dateTimeAddHours :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeAddMinutes :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeAddMonths :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeAddSeconds :: (HasCallStack, MonadIO m) => DateTime -> Double -> m DateTime
- dateTimeAddWeeks :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeAddYears :: (HasCallStack, MonadIO m) => DateTime -> Int32 -> m DateTime
- dateTimeCompare :: (HasCallStack, MonadIO m) => Ptr () -> Ptr () -> m Int32
- dateTimeDifference :: (HasCallStack, MonadIO m) => DateTime -> DateTime -> m Int64
- dateTimeEqual :: (HasCallStack, MonadIO m) => Ptr () -> Ptr () -> m Bool
- dateTimeFormat :: (HasCallStack, MonadIO m) => DateTime -> Text -> m Text
- dateTimeGetDayOfMonth :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetDayOfWeek :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetDayOfYear :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetHour :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetMicrosecond :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetMinute :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetMonth :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetSecond :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetSeconds :: (HasCallStack, MonadIO m) => DateTime -> m Double
- dateTimeGetTimezone :: (HasCallStack, MonadIO m) => DateTime -> m TimeZone
- dateTimeGetTimezoneAbbreviation :: (HasCallStack, MonadIO m) => DateTime -> m Text
- dateTimeGetUtcOffset :: (HasCallStack, MonadIO m) => DateTime -> m Int64
- dateTimeGetWeekNumberingYear :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetWeekOfYear :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetYear :: (HasCallStack, MonadIO m) => DateTime -> m Int32
- dateTimeGetYmd :: (HasCallStack, MonadIO m) => DateTime -> m (Int32, Int32, Int32)
- dateTimeHash :: (HasCallStack, MonadIO m) => Ptr () -> m Word32
- dateTimeIsDaylightSavings :: (HasCallStack, MonadIO m) => DateTime -> m Bool
- dateTimeNew :: (HasCallStack, MonadIO m) => TimeZone -> Int32 -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> m DateTime
- dateTimeNewFromIso8601 :: (HasCallStack, MonadIO m) => Text -> Maybe TimeZone -> m (Maybe DateTime)
- dateTimeNewFromTimevalLocal :: (HasCallStack, MonadIO m) => TimeVal -> m DateTime
- dateTimeNewFromTimevalUtc :: (HasCallStack, MonadIO m) => TimeVal -> m DateTime
- dateTimeNewFromUnixLocal :: (HasCallStack, MonadIO m) => Int64 -> m DateTime
- dateTimeNewFromUnixUtc :: (HasCallStack, MonadIO m) => Int64 -> m DateTime
- dateTimeNewLocal :: (HasCallStack, MonadIO m) => Int32 -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> m DateTime
- dateTimeNewNow :: (HasCallStack, MonadIO m) => TimeZone -> m DateTime
- dateTimeNewNowLocal :: (HasCallStack, MonadIO m) => m DateTime
- dateTimeNewNowUtc :: (HasCallStack, MonadIO m) => m DateTime
- dateTimeNewUtc :: (HasCallStack, MonadIO m) => Int32 -> Int32 -> Int32 -> Int32 -> Int32 -> Double -> m DateTime
- dateTimeRef :: (HasCallStack, MonadIO m) => DateTime -> m DateTime
- dateTimeToLocal :: (HasCallStack, MonadIO m) => DateTime -> m DateTime
- dateTimeToTimeval :: (HasCallStack, MonadIO m) => DateTime -> TimeVal -> m Bool
- dateTimeToTimezone :: (HasCallStack, MonadIO m) => DateTime -> TimeZone -> m DateTime
- dateTimeToUnix :: (HasCallStack, MonadIO m) => DateTime -> m Int64
- dateTimeToUtc :: (HasCallStack, MonadIO m) => DateTime -> m DateTime
- dateTimeUnref :: (HasCallStack, MonadIO m) => DateTime -> m ()

# Exported types

newtype DateTime Source #

Memory-managed wrapper type.

Constructors

DateTime (ManagedPtr DateTime) |

Instances

BoxedObject DateTime Source # |
Instance details Defined in GI.GLib.Structs.DateTime Methods boxedType :: DateTime -> IO GType Source #

noDateTime :: Maybe DateTime Source #

A convenience alias for `Nothing` :: `Maybe` `DateTime`.

# Methods

## add

dateTimeAdd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int64 | `timespan`: a `GTimeSpan`
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified timespan to the copy.

Since: 2.26

## addDays

dateTimeAddDays Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `days`: the number of days
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of days to the copy. Add negative values to subtract days.

Since: 2.26

## addFull

dateTimeAddFull Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `years`: the number of years to add
-> Int32 | `months`: the number of months to add
-> Int32 | `days`: the number of days to add
-> Int32 | `hours`: the number of hours to add
-> Int32 | `minutes`: the number of minutes to add
-> Double | `seconds`: the number of seconds to add
-> m DateTime | Returns: the newly created `DateTime` that should be freed with `dateTimeUnref`.

Creates a new `DateTime` adding the specified values to the current date and time in `datetime`. Add negative values to subtract.

Since: 2.26

## addHours

dateTimeAddHours Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `hours`: the number of hours to add
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of hours. Add negative values to subtract hours.

Since: 2.26

## addMinutes

dateTimeAddMinutes Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `minutes`: the number of minutes to add
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` adding the specified number of minutes. Add negative values to subtract minutes.

Since: 2.26

## addMonths

dateTimeAddMonths Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `months`: the number of months
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of months to the copy. Add negative values to subtract months.

The day of the month of the resulting `DateTime` is clamped to the number of days in the updated calendar month. For example, if adding 1 month to 31st January 2018, the result would be 28th February 2018. In 2020 (a leap year), the result would be 29th February.

Since: 2.26

## addSeconds

dateTimeAddSeconds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Double | `seconds`: the number of seconds to add
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of seconds. Add negative values to subtract seconds.

Since: 2.26

## addWeeks

dateTimeAddWeeks Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `weeks`: the number of weeks
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of weeks to the copy. Add negative values to subtract weeks.

Since: 2.26

## addYears

dateTimeAddYears Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> Int32 | `years`: the number of years
-> m DateTime | Returns: the newly created `DateTime` which should be freed with `dateTimeUnref`.

Creates a copy of `datetime` and adds the specified number of years to the copy. Add negative values to subtract years.

As with `dateTimeAddMonths`, if the resulting date would be 29th February on a non-leap year, the day will be clamped to 28th February.

Since: 2.26

## compare

dateTimeCompare Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Ptr () | `dt1`: first `DateTime` to compare
-> Ptr () | `dt2`: second `DateTime` to compare
-> m Int32 | Returns: -1, 0 or 1 if `dt1` is less than, equal to or greater than `dt2`.

A comparison function for `GDateTimes` that is suitable as a `CompareFunc`. Both `GDateTimes` must be non-`Nothing`.

Since: 2.26

## difference

dateTimeDifference Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `end`: a `DateTime`
-> DateTime | `begin`: a `DateTime`
-> m Int64 | Returns: the difference between the two `DateTime`, as a time span expressed in microseconds.

Calculates the difference in time between `end` and `begin`. The `GTimeSpan` that is returned is effectively `end` - `begin` (ie: positive if the first parameter is larger).

Since: 2.26

## equal

dateTimeEqual Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Ptr () | `dt1`: a `DateTime`
-> Ptr () | `dt2`: a `DateTime`
-> m Bool | Returns: `True` if `dt1` and `dt2` are equal

Checks to see if `dt1` and `dt2` are equal.

Equal here means that they represent the same moment after converting them to the same time zone.

Since: 2.26

## format

dateTimeFormat Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: A `DateTime`
-> Text | `format`: a valid UTF-8 string, containing the format for the `DateTime`
-> m Text | Returns: a newly allocated string formatted to the requested format or `Nothing` in the case that there was an error (such as a format specifier not being supported in the current locale). The string should be freed with `free`.

Creates a newly allocated string representing the requested `format`.

The format strings understood by this function are a subset of the `strftime()` format language as specified by C99. The %D, %U and %W conversions are not supported, nor is the 'E' modifier. The GNU extensions %k, %l, %s and %P are supported, however, as are the '0', '_' and '-' modifiers.

In contrast to `strftime()`, this function always produces a UTF-8 string, regardless of the current locale. Note that the rendering of many formats is locale-dependent and may not match the `strftime()` output exactly.

The following format specifiers are supported:

- %a: the abbreviated weekday name according to the current locale
- %A: the full weekday name according to the current locale
- %b: the abbreviated month name according to the current locale
- %B: the full month name according to the current locale
- %c: the preferred date and time representation for the current locale
- %C: the century number (year/100) as a 2-digit integer (00-99)
- %d: the day of the month as a decimal number (range 01 to 31)
- %e: the day of the month as a decimal number (range 1 to 31)
- %F: equivalent to `%Y-%m-%d` (the ISO 8601 date format)
- %g: the last two digits of the ISO 8601 week-based year as a decimal number (00-99). This works well with %V and %u.
- %G: the ISO 8601 week-based year as a decimal number. This works well with %V and %u.
- %h: equivalent to %b
- %H: the hour as a decimal number using a 24-hour clock (range 00 to 23)
- %I: the hour as a decimal number using a 12-hour clock (range 01 to 12)
- %j: the day of the year as a decimal number (range 001 to 366)
- %k: the hour (24-hour clock) as a decimal number (range 0 to 23); single digits are preceded by a blank
- %l: the hour (12-hour clock) as a decimal number (range 1 to 12); single digits are preceded by a blank
- %m: the month as a decimal number (range 01 to 12)
- %M: the minute as a decimal number (range 00 to 59)
- %p: either "AM" or "PM" according to the given time value, or the corresponding strings for the current locale. Noon is treated as "PM" and midnight as "AM".
- %P: like %p but lowercase: "am" or "pm" or a corresponding string for the current locale
- %r: the time in a.m. or p.m. notation
- %R: the time in 24-hour notation (%H:%M)
- %s: the number of seconds since the Epoch, that is, since 1970-01-01 00:00:00 UTC
- %S: the second as a decimal number (range 00 to 60)
- %t: a tab character
- %T: the time in 24-hour notation with seconds (%H:%M:%S)
- %u: the ISO 8601 standard day of the week as a decimal, range 1 to 7, Monday being 1. This works well with %G and %V.
- %V: the ISO 8601 standard week number of the current year as a decimal number, range 01 to 53, where week 1 is the first week that has at least 4 days in the new year. See `dateTimeGetWeekOfYear`. This works well with %G and %u.
- %w: the day of the week as a decimal, range 0 to 6, Sunday being 0. This is not the ISO 8601 standard format -- use %u instead.
- %x: the preferred date representation for the current locale without the time
- %X: the preferred time representation for the current locale without the date
- %y: the year as a decimal number without the century
- %Y: the year as a decimal number including the century
- %z: the time zone as an offset from UTC (+hhmm)
- %:z: the time zone as an offset from UTC (+hh:mm). This is a gnulib `strftime()` extension. Since: 2.38
- %::z: the time zone as an offset from UTC (+hh:mm:ss). This is a gnulib `strftime()` extension. Since: 2.38
- %:::z: the time zone as an offset from UTC, with : to necessary precision (e.g., -04, +05:30). This is a gnulib `strftime()` extension. Since: 2.38
- %Z: the time zone or name or abbreviation
- %%: a literal % character

Some conversion specifications can be modified by preceding the conversion specifier by one or more modifier characters. The following modifiers are supported for many of the numeric conversions:

- O: Use alternative numeric symbols, if the current locale supports those.
- _: Pad a numeric result with spaces. This overrides the default padding for the specifier.
- -: Do not pad a numeric result. This overrides the default padding for the specifier.
- 0: Pad a numeric result with zeros. This overrides the default padding for the specifier.

Additionally, when O is used with B, b, or h, it produces the alternative form of a month name. The alternative form should be used when the month name is used without a day number (e.g., standalone). It is required in some languages (Baltic, Slavic, Greek, and more) due to their grammatical rules. For other languages there is no difference. %OB is a GNU and BSD `strftime()` extension expected to be added to the future POSIX specification, %Ob and %Oh are GNU `strftime()` extensions. Since: 2.56

Since: 2.26

## getDayOfMonth

dateTimeGetDayOfMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the day of the month

Retrieves the day of the month represented by `datetime` in the gregorian calendar.

Since: 2.26

## getDayOfWeek

dateTimeGetDayOfWeek Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the day of the week

Retrieves the ISO 8601 day of the week on which `datetime` falls (1 is Monday, 2 is Tuesday... 7 is Sunday).

Since: 2.26

## getDayOfYear

dateTimeGetDayOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the day of the year

Retrieves the day of the year represented by `datetime` in the Gregorian calendar.

Since: 2.26

## getHour

dateTimeGetHour Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the hour of the day

Retrieves the hour of the day represented by `datetime`

Since: 2.26

## getMicrosecond

dateTimeGetMicrosecond Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the microsecond of the second

Retrieves the microsecond of the date represented by `datetime`

Since: 2.26

## getMinute

dateTimeGetMinute Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the minute of the hour

Retrieves the minute of the hour represented by `datetime`

Since: 2.26

## getMonth

dateTimeGetMonth Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the month represented by `datetime`

Retrieves the month of the year represented by `datetime` in the Gregorian calendar.

Since: 2.26

## getSecond

dateTimeGetSecond Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the second represented by `datetime`

Retrieves the second of the minute represented by `datetime`

Since: 2.26

## getSeconds

dateTimeGetSeconds Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Double | Returns: the number of seconds

Retrieves the number of seconds since the start of the last minute, including the fractional part.

Since: 2.26

## getTimezone

dateTimeGetTimezone Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m TimeZone | Returns: the time zone

Get the time zone for this `datetime`.

Since: 2.58

## getTimezoneAbbreviation

dateTimeGetTimezoneAbbreviation Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Text | Returns: the time zone abbreviation. The returned string is owned by the `DateTime` and it should not be modified or freed

Determines the time zone abbreviation to be used at the time and in the time zone of `datetime`.

For example, in Toronto this is currently "EST" during the winter months and "EDT" during the summer months when daylight savings time is in effect.

Since: 2.26

## getUtcOffset

dateTimeGetUtcOffset Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int64 | Returns: the number of microseconds that should be added to UTC to get the local time

Determines the offset to UTC in effect at the time and in the time zone of `datetime`.

The offset is the number of microseconds that you add to UTC time to arrive at local time for the time zone (ie: negative numbers for time zones west of GMT, positive numbers for east).

If `datetime` represents UTC time, then the offset is always zero.

Since: 2.26

## getWeekNumberingYear

dateTimeGetWeekNumberingYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the ISO 8601 week-numbering year for `datetime`

Returns the ISO 8601 week-numbering year in which the week containing `datetime` falls.

This function, taken together with `dateTimeGetWeekOfYear` and `dateTimeGetDayOfWeek` can be used to determine the full ISO week date on which `datetime` falls.

This is usually equal to the normal Gregorian year (as returned by `dateTimeGetYear`), except as detailed below:

For Thursday, the week-numbering year is always equal to the usual calendar year. For other days, the number is such that every day within a complete week (Monday to Sunday) is contained within the same week-numbering year.

For Monday, Tuesday and Wednesday occurring near the end of the year, this may mean that the week-numbering year is one greater than the calendar year (so that these days have the same week-numbering year as the Thursday occurring early in the next year).

For Friday, Saturday and Sunday occurring near the start of the year, this may mean that the week-numbering year is one less than the calendar year (so that these days have the same week-numbering year as the Thursday occurring late in the previous year).

An equivalent description is that the week-numbering year is equal to the calendar year containing the majority of the days in the current week (Monday to Sunday).

Note that January 1 0001 in the proleptic Gregorian calendar is a Monday, so this function never returns 0.

Since: 2.26

## getWeekOfYear

dateTimeGetWeekOfYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int32 | Returns: the ISO 8601 week number for `datetime`.

Returns the ISO 8601 week number for the week containing `datetime`. The ISO 8601 week number is the same for every day of the week (from Moday through Sunday). That can produce some unusual results (described below).

The first week of the year is week 1. This is the week that contains the first Thursday of the year. Equivalently, this is the first week that has more than 4 of its days falling within the calendar year.

The value 0 is never returned by this function. Days contained within a year but occurring before the first ISO 8601 week of that year are considered as being contained in the last week of the previous year. Similarly, the final days of a calendar year may be considered as being part of the first ISO 8601 week of the next year if 4 or more days of that week are contained within the new year.

Since: 2.26

## getYear

dateTimeGetYear Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: A `DateTime`
-> m Int32 | Returns: the year represented by `datetime`

Retrieves the year represented by `datetime` in the Gregorian calendar.

Since: 2.26

## getYmd

dateTimeGetYmd Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`.
-> m (Int32, Int32, Int32) |

Retrieves the Gregorian day, month, and year of a given `DateTime`.

Since: 2.26

## hash

dateTimeHash Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Ptr () | `datetime`: a `DateTime`
-> m Word32 | Returns: a `guint` containing the hash

Hashes `datetime` into a `guint`, suitable for use within `HashTable`.

Since: 2.26

## isDaylightSavings

dateTimeIsDaylightSavings Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Bool | Returns: `True` if daylight savings time is in effect

Determines if daylight savings time is in effect at the time and in the time zone of `datetime`.

Since: 2.26

## new

dateTimeNew Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TimeZone | `tz`: a `TimeZone`
-> Int32 | `year`: the year component of the date
-> Int32 | `month`: the month component of the date
-> Int32 | `day`: the day component of the date
-> Int32 | `hour`: the hour component of the date
-> Int32 | `minute`: the minute component of the date
-> Double | `seconds`: the number of seconds past the minute
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a new `DateTime` corresponding to the given date and time in the time zone `tz`.

The `year` must be between 1 and 9999, `month` between 1 and 12 and `day` between 1 and 28, 29, 30 or 31 depending on the month and the year.

`hour` must be between 0 and 23 and `minute` must be between 0 and 59.

`seconds` must be at least 0.0 and must be strictly less than 60.0. It will be rounded down to the nearest microsecond.

If the given time is not representable in the given time zone (for example, 02:30 on March 14th 2010 in Toronto, due to daylight savings time) then the time will be rounded up to the nearest existing time (in this case, 03:00). If this matters to you then you should verify the return value for containing the same as the numbers you gave.

In the case that the given time is ambiguous in the given time zone (for example, 01:30 on November 7th 2010 in Toronto, due to daylight savings time) then the time falling within standard (ie: non-daylight) time is taken.

It not considered a programmer error for the values to this function to be out of range, but in the case that they are, the function will return `Nothing`.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newFromIso8601

dateTimeNewFromIso8601 Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Text | `text`: an ISO 8601 formatted time string.
-> Maybe TimeZone | `defaultTz`: a `TimeZone` to use if the text doesn't contain a timezone, or `Nothing`.
-> m (Maybe DateTime) | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to the given ISO 8601 formatted string `text`. ISO 8601 strings of the form <date><sep><time><tz> are supported.

<sep> is the separator and can be either 'T', 't' or ' '.

<date> is in the form:

- `YYYY-MM-DD` - Year/month/day, e.g. 2016-08-24.
- `YYYYMMDD` - Same as above without dividers.
- `YYYY-DDD` - Ordinal day where DDD is from 001 to 366, e.g. 2016-237.
- `YYYYDDD` - Same as above without dividers.
- `YYYY-Www-D` - Week day where ww is from 01 to 52 and D from 1-7, e.g. 2016-W34-3.
- `YYYYWwwD` - Same as above without dividers.

<time> is in the form:

- `hh:mm:ss(.sss)` - Hours, minutes, seconds (subseconds), e.g. 22:10:42.123.
- `hhmmss(.sss)` - Same as above without dividers.

<tz> is an optional timezone suffix of the form:

- `Z` - UTC.
- `+hh:mm` or `-hh:mm` - Offset from UTC in hours and minutes, e.g. +12:00.
- `+hh` or `-hh` - Offset from UTC in hours, e.g. +12.

If the timezone is not provided in `text` it must be provided in `defaultTz` (this field is otherwise ignored).

This call can fail (returning `Nothing`) if `text` is not a valid ISO 8601 formatted string.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.56

## newFromTimevalLocal

dateTimeNewFromTimevalLocal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TimeVal | `tv`: a `TimeVal`
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to the given `TimeVal` `tv` in the local time zone.

The time contained in a `TimeVal` is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `Nothing`) if `tv` represents a time outside of the supported range of `DateTime`.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newFromTimevalUtc

dateTimeNewFromTimevalUtc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TimeVal | `tv`: a `TimeVal`
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to the given `TimeVal` `tv` in UTC.

The time contained in a `TimeVal` is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `Nothing`) if `tv` represents a time outside of the supported range of `DateTime`.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newFromUnixLocal

dateTimeNewFromUnixLocal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Int64 | `t`: the Unix time
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to the given Unix time `t` in the local time zone.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the local time offset.

This call can fail (returning `Nothing`) if `t` represents a time outside of the supported range of `DateTime`.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newFromUnixUtc

dateTimeNewFromUnixUtc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Int64 | `t`: the Unix time
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to the given Unix time `t` in UTC.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC.

This call can fail (returning `Nothing`) if `t` represents a time outside of the supported range of `DateTime`.

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newLocal

dateTimeNewLocal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Int32 | `year`: the year component of the date
-> Int32 | `month`: the month component of the date
-> Int32 | `day`: the day component of the date
-> Int32 | `hour`: the hour component of the date
-> Int32 | `minute`: the minute component of the date
-> Double | `seconds`: the number of seconds past the minute
-> m DateTime | Returns: a `DateTime`, or `Nothing`

Creates a new `DateTime` corresponding to the given date and time in the local time zone.

This call is equivalent to calling `dateTimeNew` with the time zone returned by `timeZoneNewLocal`.

Since: 2.26

## newNow

dateTimeNewNow Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> TimeZone | `tz`: a `TimeZone`
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to this exact instant in the given time zone `tz`. The time is as accurate as the system allows, to a maximum accuracy of 1 microsecond.

This function will always succeed unless the system clock is set to truly insane values (or unless GLib is still being used after the year 9999).

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## newNowLocal

dateTimeNewNowLocal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to this exact instant in the local time zone.

This is equivalent to calling `dateTimeNewNow` with the time zone returned by `timeZoneNewLocal`.

Since: 2.26

## newNowUtc

dateTimeNewNowUtc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> m DateTime | Returns: a new `DateTime`, or `Nothing`

Creates a `DateTime` corresponding to this exact instant in UTC.

This is equivalent to calling `dateTimeNewNow` with the time zone returned by `timeZoneNewUtc`.

Since: 2.26

## newUtc

dateTimeNewUtc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> Int32 | `year`: the year component of the date
-> Int32 | `month`: the month component of the date
-> Int32 | `day`: the day component of the date
-> Int32 | `hour`: the hour component of the date
-> Int32 | `minute`: the minute component of the date
-> Double | `seconds`: the number of seconds past the minute
-> m DateTime | Returns: a `DateTime`, or `Nothing`

Creates a new `DateTime` corresponding to the given date and time in UTC.

This call is equivalent to calling `dateTimeNew` with the time zone returned by `timeZoneNewUtc`.

Since: 2.26

## ref

dateTimeRef Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m DateTime | Returns: the `DateTime` with the reference count increased

Atomically increments the reference count of `datetime` by one.

Since: 2.26

## toLocal

dateTimeToLocal Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m DateTime | Returns: the newly created `DateTime`

Creates a new `DateTime` corresponding to the same instant in time as `datetime`, but in the local time zone.

This call is equivalent to calling `dateTimeToTimezone` with the time zone returned by `timeZoneNewLocal`.

Since: 2.26

## toTimeval

dateTimeToTimeval Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> TimeVal | `tv`: a `TimeVal` to modify
-> m Bool | Returns: `True` if successful, else `False`

Stores the instant in time that `datetime` represents into `tv`.

The time contained in a `TimeVal` is always stored in the form of seconds elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with `datetime`.

On systems where 'long' is 32bit (ie: all 32bit systems and all Windows systems), a `TimeVal` is incapable of storing the entire range of values that `DateTime` is capable of expressing. On those systems, this function returns `False` to indicate that the time is out of range.

On systems where 'long' is 64bit, this function never fails.

Since: 2.26

## toTimezone

dateTimeToTimezone Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> TimeZone | `tz`: the new `TimeZone`
-> m DateTime | Returns: a new `DateTime`, or `Nothing`

Create a new `DateTime` corresponding to the same instant in time as `datetime`, but in the time zone `tz`.

This call can fail in the case that the time goes out of bounds. For example, converting 0001-01-01 00:00:00 UTC to a time zone west of Greenwich will fail (due to the year 0 being out of range).

You should release the return value by calling `dateTimeUnref` when you are done with it.

Since: 2.26

## toUnix

dateTimeToUnix Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m Int64 | Returns: the Unix time corresponding to `datetime`

Gives the Unix time corresponding to `datetime`, rounding down to the nearest second.

Unix time is the number of seconds that have elapsed since 1970-01-01 00:00:00 UTC, regardless of the time zone associated with `datetime`.

Since: 2.26

## toUtc

dateTimeToUtc Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m DateTime | Returns: the newly created `DateTime`

Creates a new `DateTime` corresponding to the same instant in time as `datetime`, but in UTC.

This call is equivalent to calling `dateTimeToTimezone` with the time zone returned by `timeZoneNewUtc`.

Since: 2.26

## unref

dateTimeUnref Source #

Arguments

:: (HasCallStack, MonadIO m) |
=> DateTime | `datetime`: a `DateTime`
-> m () |

Atomically decrements the reference count of `datetime` by one.

When the reference count reaches zero, the resources allocated by `datetime` are freed

Since: 2.26